/*
	calc.cpp
	
	(c) Richard Thrippleton, July 2001
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

#include <stdio.h>
#include <math.h>
#include "calc.h"

long cosc[360]; //Cached cosines
long sinc[360]; //Cached sines. Both not actually correct, warped for my preferred co-ordinate system (Up is 0 degrees, go round clockwise, down is Y positive)
short angc[100][100]; //Angle cache for vector to polar conversion

void initcalc()
{
	double rad; //Angle in radians
	
	for(short i=0;i<360;i++)
	{
		rad=((double)(90-i)/180)*M_PI;	
		cosc[i]=(cos(rad)*100);
		sinc[i]=-(sin(rad)*100);
	}
	for(short x=0;x<100;x++)
	{
		for(short y=0;y<100;y++)
		{
			rad=90+(atan((double)y/(double)x)/(M_PI/180));
			angc[x][y]=rad;
		}
	}
	fflush(NULL);
}

vct poltovct(pol in,bool hres)
{
	vct out; //Calculated vector
	
	out.xx=(cosc[in.ang]*in.rad);
	out.yy=(sinc[in.ang]*in.rad);
	if(!hres)
	{
		out.xx/=100;
		out.yy/=100;
	}
	return out;
}

pol vcttopol(vct in)
{
	pol out; //Calculated polar
	
	out.rad=sqrt(in.xx*in.xx+in.yy*in.yy);
	in.xx*=100;
	in.yy*=100;
	in.xx/=out.rad;
	in.yy/=out.rad;
	if(in.xx==100)
		in.xx=99;
	if(in.xx==-100)
		in.xx=-99;
	if(in.yy==100)
		in.yy=99;
	if(in.yy==-100)
		in.yy=-99;
	out.ang=-1;
	//printf("%d , %d\n",in.xx,in.yy);

	if(in.yy>=0)
		if(in.xx>=0)
			out.ang=angc[in.xx][in.yy];
		else
			out.ang=360-angc[-in.xx][in.yy];
	else
		if(in.xx>=0)
			out.ang=180-angc[in.xx][-in.yy];
		else
			out.ang=180+angc[-in.xx][-in.yy];
	return out;
}
