/*
	frag.cpp
	
	(c) Richard Thrippleton, July 2001
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

#include <stdio.h>
#include <SDL.h>
#include "calc.h"
#include "ship.h"
#include "graphics.h"
#include "frag.h"

extern sprite sprites[];
extern pers me;
frag frags[FRAGCOUNT]; //Frag database

void initfrags()
{
	for(short i=0;i<FRAGCOUNT;i++)
	{
		frags[i].typ=-1;
	}
}

void drawfrags()
{
	for(short i=0;i<FRAGCOUNT;i++)
	{
		if(frags[i].typ!=-1)
		{
			frags[i].draw();
		}
	}
}

void dofrags()
{
	for(short i=0;i<FRAGCOUNT;i++)
	{
		if(frags[i].typ!=-1)
		{
			frags[i].physics();
		}
	}	
}

void newfrag(frag* in)
{
	for(short i=0;i<FRAGCOUNT;i++)
	{
		if(frags[i].typ==-1)
		{
			frags[i]=*in;
			return;
		}
	}
}

void frag::draw()
{
	short ax,ay; //Position on screen
	
	ax=x-me.x+200;
	ay=y-me.y+200;
	if(!(ax>450||ax<-50||ay>450||ay<-50))
	{
		sprites[spr].draw(ax,ay,rot);
	}
}

void frag::physics()
{
	x+=vel.xx;
	y+=vel.yy;
	rng--;
	if(rng<1)
	{
		typ=-1;
	}
}
