/*
	frag.h
	
	(c) Richard Thrippleton, July 2001
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

class frag //A frag object, like phaser fire, torpedo, debris
{
	public:
	
	short typ; //Type: -1 Non-existent  1 Phaser fire  2 Torpedo  3 Debris
	short spr; //Associated sprite
	long x,y; //Position
	vct vel; //Velocity
	short rot; //Rotation frame to use
	short pow; //Power/damage
	long trck; //Tracking power
	short rng; //Range left
	
	void draw(); //Draw the frag
	void physics(); //Move the frag, do collisions
};

void initfrags(); //Initialises all the frags in the database
void drawfrags(); //Draw all frags in view
void dofrags(); //Run physics on all frags
void newfrag(frag* in); //Creates a new frag

const short FRAGCOUNT=512; //Total number of frags in database
