/*
	sv.cpp
	
	(c) Richard Thrippleton, July 2001
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include <SDL.h>
#include "calc.h"
#include "sv.h"
#include "ship.h"
#include "graphics.h"
#include "equip.h"
#include "frag.h"

int main(int argc,char* argv[])
{
	const Uint32 dly=50; //Delay in milliseconds to achieve 20fps
	timespec fps;
	Uint32 ntm,otm,dif; //Time values, for fps restriction in the loop
	
	srand(getpid());
	initcalc();
	initequip();
	initgraphics();
	initships();
	initfrags();
	testship();
	fps.tv_sec=0;
	for(;;)
	{
		otm=SDL_GetTicks();
//		printf("dofrags\n");
//		fflush(NULL);
		dofrags();
//		printf("doships\n");
//		fflush(NULL);
		doships();
//		printf("drawinterface\n");
//		fflush(NULL);
		drawinterface();
//		printf("drawships\n");
//		fflush(NULL);
		drawships();
//		printf("drawfrags\n");
//		fflush(NULL);
		drawfrags();
		update();
		ntm=SDL_GetTicks();
		dif=dly-(ntm-otm);
		if(dif>0)
		{
			fps.tv_nsec=dif*1000000;
			nanosleep(&fps,NULL);
		}
	}
	SDL_Quit();
	return 0;
}
